<?php

namespace App\Filament\Exports;

use App\Models\InvoiceDataValidation;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class InvoiceDataValidationExporter extends Exporter
{
    protected static ?string $model = InvoiceDataValidation::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.code')
            ->label('PLANT'),
            ExportColumn::make('distribution_channel_desc')
            ->label('DISTRIBUTION CHANNEL DESC'),
            ExportColumn::make('customer_code')
            ->label('CUSTOMER CODE'),
            ExportColumn::make('document_number')
            ->label('DOCUMENT NUMBER'),
            ExportColumn::make('document_date')
            ->label('DOCUMENT DATE'),
            ExportColumn::make('customer_trade_name')
            ->label('CUSTOMER TRADE NAME'),
            ExportColumn::make('customer_location')
            ->label('CUSTOMER LOCATION'),
            ExportColumn::make('location')
            ->label('LOCATION'),
            ExportColumn::make('created_at')
            ->label('CREATED AT'),
            ExportColumn::make('updated_at')
            ->label('UPDATED AT'),
            ExportColumn::make('created_by')
            ->label('CREATED BY'),
            ExportColumn::make('updated_by')
            ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
            ->enabledByDefault(false)
            ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your invoice data validation export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
